Index: trunk/demos/CircleFollower/uav/build_arm/bin/CircleFollower_hdsx8.xml
===================================================================
--- trunk/demos/CircleFollower/uav/build_arm/bin/CircleFollower_hdsx8.xml	(revision 171)
+++ trunk/demos/CircleFollower/uav/build_arm/bin/CircleFollower_hdsx8.xml	(revision 172)
@@ -64,5 +64,5 @@
   <PushButton value="0" name="f8"/>
   <PushButton value="0" name="Start_Obs"/>
- <GridLayout name="buttons"><PushButton name="kill"/><PushButton name="start_log"/><PushButton name="stop_log"/><PushButton name="take_off"/><PushButton name="land"/><PushButton name="f1"/><PushButton name="f2"/><PushButton name="f3"/><PushButton name="f4"/><PushButton name="Reset"/><PushButton name="Start_Obs"/><PushButton name="Optical_flow"/><PushButton name="start_circle"/><PushButton name="stop_circle"/></GridLayout><GroupBox name="takeoff/landing"><DoubleSpinBox name="desired takeoff altitude" value="1"/><DoubleSpinBox name="desired landing altitude" value="0"/></GroupBox><GroupBox name="alt cons"><DoubleSpinBox name="period, 0 for auto:" value="0"/><DoubleSpinBox name="velocity max (absolute):" value="0.3"/><DoubleSpinBox name="acceleration (absolute):" value="0.2"/></GroupBox></Tab>
+ <GridLayout name="buttons"><PushButton name="kill"/><PushButton name="start_log"/><PushButton name="stop_log"/><PushButton name="take_off"/><PushButton name="land"/><PushButton name="f1"/><PushButton name="f2"/><PushButton name="f3"/><PushButton name="f4"/><PushButton name="Reset"/><PushButton name="Start_Obs"/><PushButton name="Optical_flow"/><PushButton name="start_circle"/><PushButton name="stop_circle"/><PushButton name="position hold"/></GridLayout><GroupBox name="takeoff/landing"><DoubleSpinBox name="desired takeoff altitude" value="1"/><DoubleSpinBox name="desired landing altitude" value="0"/></GroupBox><GroupBox name="alt cons"><DoubleSpinBox name="period, 0 for auto:" value="0"/><DoubleSpinBox name="velocity max (absolute):" value="0.3"/><DoubleSpinBox name="acceleration (absolute):" value="0.2"/></GroupBox></Tab>
  <Tab name="multi">
   <TabWidget name="UavMultiplex">
@@ -232,5 +232,5 @@
     </DataPlot1D>
    </Tab>
-  </TabWidget>
+  <Tab name="Quaternion"><DataPlot1D name="q0" period="100" enabled="0"/><DataPlot1D name="q1" period="100" enabled="0"/><DataPlot1D name="q2" period="100" enabled="0"/><DataPlot1D name="q3" period="100" enabled="0"/></Tab><Tab name="IMU"><DataPlot1D name="acc_x" period="100" enabled="0"/><DataPlot1D name="acc_y" period="100" enabled="0"/><DataPlot1D name="acc_z" period="100" enabled="0"/><DataPlot1D name="gyr_x" period="100" enabled="0"/><DataPlot1D name="gyr_y" period="100" enabled="0"/><DataPlot1D name="gyr_z" period="100" enabled="0"/><DataPlot1D name="mag_x" period="100" enabled="0"/><DataPlot1D name="mag_y" period="100" enabled="0"/><DataPlot1D name="mag_z" period="100" enabled="0"/></Tab></TabWidget>
  </Tab>
  <Tab name="control laws">
@@ -337,5 +337,5 @@
      <DoubleSpinBox value="0.0001" name="offset step:"/>
     </GroupBox>
-   <GroupBox name="u_x"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="kp:" value="0.010"/><DoubleSpinBox name="ki:" value="0.030"/><DoubleSpinBox name="sat i:" value="0.30"/><DoubleSpinBox name="kd:" value="0"/><DoubleSpinBox name="sat:" value="0.50"/></GroupBox><GroupBox name="u_y"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="kp:" value="0.010"/><DoubleSpinBox name="ki:" value="0.030"/><DoubleSpinBox name="sat i:" value="0.30"/><DoubleSpinBox name="kd:" value="0"/><DoubleSpinBox name="sat:" value="0.50"/></GroupBox></Tab>
+   <GroupBox name="u_x"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="kp:" value="0.40"/><DoubleSpinBox name="ki:" value="0.40"/><DoubleSpinBox name="sat i:" value="0.0"/><DoubleSpinBox name="kd:" value="0.200"/><DoubleSpinBox name="sat:" value="0.4"/></GroupBox><GroupBox name="u_y"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="kp:" value="0.40"/><DoubleSpinBox name="ki:" value="0.40"/><DoubleSpinBox name="sat i:" value="0.0"/><DoubleSpinBox name="kd:" value="0.200"/><DoubleSpinBox name="sat:" value="0.4"/></GroupBox></Tab>
    <Tab name="Graphes">
     <DataPlot1D name="u_roll" period="100" enabled="0">
@@ -422,7 +422,7 @@
      <DoubleSpinBox value="0" name="period, 0 for auto:"/>
     </GroupBox>
-   <GroupBox name="target Passe bas"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox><GroupBox name="target_euler"><DoubleSpinBox name="period, 0 for auto:" value="0"/></GroupBox><GroupBox name="circle"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="R" value="1.00"/><DoubleSpinBox name="velocity" value="0.50"/><DoubleSpinBox name="acceleration (absolute)" value="0.10"/></GroupBox></Tab>
+   <GroupBox name="target Passe bas"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox><GroupBox name="target_euler"><DoubleSpinBox name="period, 0 for auto:" value="0"/></GroupBox><GroupBox name="circle"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="R" value="1"/><DoubleSpinBox name="velocity" value="0.5"/><DoubleSpinBox name="acceleration (absolute)" value="0.1"/></GroupBox></Tab>
    <Tab name="Mesures x8_0">
-    <DataPlot1D name="x" period="100" enabled="0">
+    <DataPlot1D name="x" period="100" enabled="1">
      <Setup period="100" enabled="1"/>
     </DataPlot1D>
@@ -475,4 +475,4 @@
   <Tab name="Mesures target"><DataPlot1D name="x" period="100" enabled="0"/><DataPlot1D name="y" period="100" enabled="0"/><DataPlot1D name="z" period="100" enabled="0"/><DataPlot1D name="vx" period="100" enabled="0"/><DataPlot1D name="vy" period="100" enabled="0"/><DataPlot1D name="vz" period="100" enabled="0"/></Tab><Tab name="Mesures (xy) target"><DataPlot2D name="xy" period="100" enabled="0"/></Tab></TabWidget>
  </Tab>
- <Tab name="camv"><TabWidget name="camv"><Tab name="Setup"><GroupBox name="camv"><DoubleSpinBox name="gain:" value="0.2"/><DoubleSpinBox name="exposure:" value="0.25"/><DoubleSpinBox name="bright:" value="0.3"/><DoubleSpinBox name="contrast:" value="0.4"/><DoubleSpinBox name="hue:" value="1"/><DoubleSpinBox name="sharpness:" value="0.5"/><DoubleSpinBox name="saturation:" value="0"/><CheckBox name="autogain:" value="0"/><CheckBox name="autoexposure:" value="0"/><CheckBox name="awb:" value="0"/><Label name="fps"/></GroupBox><GridLayout name="setup"><GroupBox name="flux optique"><GroupBox name="post rotation"><DoubleSpinBox name="value" value="-90"/><ComboBox name="axis" value="2"/></GroupBox><SpinBox name="max features:" value="64"/></GroupBox><GroupBox name="passe bas"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="5"/></GroupBox></GridLayout></Tab><Tab name="Picture"><Picture name="camv" period="200" enabled="0"/></Tab></TabWidget></Tab><Tab name="flux optique"><DataPlot1D name="x_velocity" period="100" enabled="0"/><DataPlot1D name="y_velocity" period="100" enabled="0"/></Tab><Tab name="motors"><TabWidget name="UavMultiplex"><Tab name="Setup"><GroupBox name="x8 multiplex"><ComboBox name="top front left blade pitch:" value="1"/></GroupBox><GroupBox name="motor attribution"><ComboBox name="top front left" value="0"/><ComboBox name="top front rigth" value="7"/><ComboBox name="top rear left" value="4"/><ComboBox name="top rear rigth" value="1"/><ComboBox name="bottom front left" value="3"/><ComboBox name="bottom front rigth" value="5"/><ComboBox name="bottom rear left" value="6"/><ComboBox name="bottom rear rigth" value="2"/></GroupBox><GroupBox name="bldc"><Label name="flight time"/><DoubleSpinBox name="min value:" value="0.20"/><DoubleSpinBox name="max value:" value="1.00"/><DoubleSpinBox name="test value:" value="0.10"/><PushButton name="test motor 0"/><PushButton name="test motor 1"/><PushButton name="test motor 2"/><PushButton name="test motor 3"/><PushButton name="test motor 4"/><PushButton name="test motor 5"/><PushButton name="test motor 6"/><PushButton name="test motor 7"/></GroupBox><GroupBox name="battery"><Label name="battery"/><DoubleSpinBox name="threshold" value="10.0"/></GroupBox><GroupBox name="Motors"><SpinBox name="nb poles:" value="14"/></GroupBox></Tab><Tab name="Values"><DataPlot1D name="front left" period="100" enabled="0"/><DataPlot1D name="front right" period="100" enabled="0"/><DataPlot1D name="rear left" period="100" enabled="0"/><DataPlot1D name="rear right" period="100" enabled="0"/></Tab><Tab name="Speeds"><DataPlot1D name="front left" period="100" enabled="0"/><DataPlot1D name="front right" period="100" enabled="0"/><DataPlot1D name="rear left" period="100" enabled="0"/><DataPlot1D name="rear right" period="100" enabled="0"/></Tab><Tab name="Currents"><DataPlot1D name="front left" period="100" enabled="0"/><DataPlot1D name="front right" period="100" enabled="0"/><DataPlot1D name="rear left" period="100" enabled="0"/><DataPlot1D name="rear right" period="100" enabled="0"/></Tab></TabWidget></Tab></TabWidget>
-<TabWidget name="App_TabWidget"><Tab name="x8_0"><PushButton name="save config on target" value="1"/></Tab></TabWidget></root>
+ <Tab name="camv"><TabWidget name="camv"><Tab name="Setup"><GroupBox name="camv"><DoubleSpinBox name="gain:" value="0.2"/><DoubleSpinBox name="exposure:" value="0.25"/><DoubleSpinBox name="bright:" value="0.3"/><DoubleSpinBox name="contrast:" value="0.4"/><DoubleSpinBox name="hue:" value="1"/><DoubleSpinBox name="sharpness:" value="0.5"/><DoubleSpinBox name="saturation:" value="0"/><CheckBox name="autogain:" value="0"/><CheckBox name="autoexposure:" value="0"/><CheckBox name="awb:" value="0"/><Label name="fps"/></GroupBox><GridLayout name="setup"><GroupBox name="flux optique"><GroupBox name="post rotation"><DoubleSpinBox name="value" value="-90"/><ComboBox name="axis" value="2"/></GroupBox><SpinBox name="max features:" value="64"/></GroupBox><GroupBox name="passe bas"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="5"/></GroupBox></GridLayout></Tab><Tab name="Picture"><Picture name="camv" period="200" enabled="0"/></Tab></TabWidget></Tab><Tab name="flux optique"><DataPlot1D name="x_velocity" period="100" enabled="0"/><DataPlot1D name="y_velocity" period="100" enabled="0"/></Tab><Tab name="motors"><TabWidget name="UavMultiplex"><Tab name="Setup"><GroupBox name="x8 multiplex"><ComboBox name="top front left blade pitch:" value="1"/></GroupBox><GroupBox name="motor attribution"><ComboBox name="top front left" value="0"/><ComboBox name="top front rigth" value="7"/><ComboBox name="top rear left" value="4"/><ComboBox name="top rear rigth" value="1"/><ComboBox name="bottom front left" value="3"/><ComboBox name="bottom front rigth" value="5"/><ComboBox name="bottom rear left" value="6"/><ComboBox name="bottom rear rigth" value="2"/></GroupBox><GroupBox name="bldc"><Label name="flight time"/><DoubleSpinBox name="min value:" value="0.2"/><DoubleSpinBox name="max value:" value="1"/><DoubleSpinBox name="test value:" value="0.1"/><PushButton name="test motor 0"/><PushButton name="test motor 1"/><PushButton name="test motor 2"/><PushButton name="test motor 3"/><PushButton name="test motor 4"/><PushButton name="test motor 5"/><PushButton name="test motor 6"/><PushButton name="test motor 7"/></GroupBox><GroupBox name="battery"><Label name="battery"/><DoubleSpinBox name="threshold" value="10"/><SpinBox name="threshold time" value="10"/></GroupBox><GroupBox name="Motors"><SpinBox name="nb poles:" value="14"/></GroupBox></Tab><Tab name="Values"><DataPlot1D name="front left" period="100" enabled="0"/><DataPlot1D name="front right" period="100" enabled="0"/><DataPlot1D name="rear left" period="100" enabled="0"/><DataPlot1D name="rear right" period="100" enabled="0"/></Tab><Tab name="Speeds"><DataPlot1D name="front left" period="100" enabled="0"/><DataPlot1D name="front right" period="100" enabled="0"/><DataPlot1D name="rear left" period="100" enabled="0"/><DataPlot1D name="rear right" period="100" enabled="0"/></Tab><Tab name="Currents"><DataPlot1D name="front left" period="100" enabled="0"/><DataPlot1D name="front right" period="100" enabled="0"/><DataPlot1D name="rear left" period="100" enabled="0"/><DataPlot1D name="rear right" period="100" enabled="0"/></Tab></TabWidget></Tab><Tab name="Dualshock3"><TabWidget name="Dualshock3"><Tab name="Reglages"><GroupBox name="consignes joy"><DoubleSpinBox name="debattement roll" value="-15"/><DoubleSpinBox name="debattement pitch" value="-15"/><DoubleSpinBox name="debattement wz" value="90"/><DoubleSpinBox name="debattement dz" value="-0.5"/><DoubleSpinBox name="trim" value="0.02"/><Label name="trim roll"/><PushButton name="reset roll trim"/><Label name="trim pitch"/><PushButton name="reset pitch trim"/></GroupBox></Tab></TabWidget></Tab></TabWidget>
+<TabWidget name="App_TabWidget"><Tab name="x8_0"><PushButton name="save config on target" value="1"/></Tab></TabWidget><PushButton name="save config on target (x8_0)" value="1"/></root>