Index: /trunk/demos/CircleFollower/uav/build_arm/bin/CircleFollower_bebop.xml
===================================================================
--- /trunk/demos/CircleFollower/uav/build_arm/bin/CircleFollower_bebop.xml	(revision 174)
+++ /trunk/demos/CircleFollower/uav/build_arm/bin/CircleFollower_bebop.xml	(revision 175)
@@ -17,6 +17,6 @@
             <Label name="flight time"/>
             <DoubleSpinBox name="min value:" value="0"/>
-            <DoubleSpinBox name="max value:" value="1.00"/>
-            <DoubleSpinBox name="test value:" value="0.40"/>
+            <DoubleSpinBox name="max value:" value="1"/>
+            <DoubleSpinBox name="test value:" value="0.4"/>
             <PushButton name="test motor 0"/>
             <PushButton name="test motor 1"/>
@@ -50,5 +50,5 @@
           <GroupBox name="Passe bas">
             <DoubleSpinBox name="period, 0 for auto" value="0"/>
-            <DoubleSpinBox name="cutoff frequency" value="5.00"/>
+            <DoubleSpinBox name="cutoff frequency" value="5"/>
           </GroupBox>
           <GroupBox name="Vz">
@@ -57,9 +57,9 @@
           <GroupBox name="Passe bas v">
             <DoubleSpinBox name="period, 0 for auto" value="0"/>
-            <DoubleSpinBox name="cutoff frequency" value="5.00"/>
+            <DoubleSpinBox name="cutoff frequency" value="5"/>
           </GroupBox>
         </Tab>
         <Tab name="Mesures">
-          <DataPlot1D name="bebop-us" period="100" enabled="0"/>
+          <DataPlot1D name="bebop-us" period="100" enabled="1"/>
           <DataPlot1D name="vz" period="100" enabled="0"/>
         </Tab>
@@ -71,5 +71,5 @@
           <GroupBox name="bebop-imu"/>
           <GroupBox name="post rotation">
-            <DoubleSpinBox name="value" value="0"/>
+            <DoubleSpinBox name="value" value="180"/>
             <ComboBox name="axis" value="0"/>
           </GroupBox>
@@ -82,8 +82,8 @@
         </Tab>
         <Tab name="AHRS">
-          <DataPlot1D name="roll" period="100" enabled="0"/>
+          <DataPlot1D name="roll" period="100" enabled="1"/>
           <DataPlot1D name="pitch" period="100" enabled="0"/>
           <DataPlot1D name="yaw" period="100" enabled="0"/>
-          <DataPlot1D name="w_x" period="100" enabled="0"/>
+          <DataPlot1D name="w_x" period="100" enabled="1"/>
           <DataPlot1D name="w_y" period="100" enabled="0"/>
           <DataPlot1D name="w_z" period="100" enabled="0"/>
@@ -116,5 +116,5 @@
             <DoubleSpinBox name="debattement wz" value="90"/>
             <DoubleSpinBox name="debattement dz" value="-0.5"/>
-            <DoubleSpinBox name="trim" value="0.02"/>
+            <DoubleSpinBox name="trim" value="0.01"/>
             <Label name="trim roll"/>
             <PushButton name="reset roll trim"/>
@@ -137,11 +137,11 @@
       </GridLayout>
       <GroupBox name="takeoff/landing">
-        <DoubleSpinBox name="desired takeoff altitude" value="1"/>
+        <DoubleSpinBox name="desired takeoff altitude" value="0.5"/>
         <DoubleSpinBox name="desired landing altitude" value="0"/>
       </GroupBox>
       <GroupBox name="alt cons">
         <DoubleSpinBox name="period, 0 for auto:" value="0"/>
-        <DoubleSpinBox name="velocity max (absolute):" value="1.00"/>
-        <DoubleSpinBox name="acceleration (absolute):" value="0.80"/>
+        <DoubleSpinBox name="velocity max (absolute):" value="1"/>
+        <DoubleSpinBox name="acceleration (absolute):" value="1"/>
       </GroupBox>
     </Tab>
@@ -150,34 +150,34 @@
         <Tab name="Setup">
           <GroupBox name="u_roll">
-            <DoubleSpinBox name="sat ref:" value="0"/>
-            <DoubleSpinBox name="kp:" value="0"/>
-            <DoubleSpinBox name="sat dref:" value="0"/>
-            <DoubleSpinBox name="kd:" value="0"/>
-            <DoubleSpinBox name="sat u:" value="0"/>
+            <DoubleSpinBox name="sat ref:" value="20"/>
+            <DoubleSpinBox name="kp:" value="15.00"/>
+            <DoubleSpinBox name="sat dref:" value="1000"/>
+            <DoubleSpinBox name="kd:" value="0.04"/>
+            <DoubleSpinBox name="sat u:" value="0.5"/>
           </GroupBox>
           <GroupBox name="u_pitch">
-            <DoubleSpinBox name="sat ref:" value="0"/>
-            <DoubleSpinBox name="kp:" value="0"/>
-            <DoubleSpinBox name="sat dref:" value="0"/>
-            <DoubleSpinBox name="kd:" value="0"/>
-            <DoubleSpinBox name="sat u:" value="0"/>
+            <DoubleSpinBox name="sat ref:" value="20"/>
+            <DoubleSpinBox name="kp:" value="15"/>
+            <DoubleSpinBox name="sat dref:" value="1000"/>
+            <DoubleSpinBox name="kd:" value="0.05"/>
+            <DoubleSpinBox name="sat u:" value="0.5"/>
           </GroupBox>
           <GroupBox name="u_yaw">
             <DoubleSpinBox name="period, 0 for auto" value="0"/>
-            <DoubleSpinBox name="kp:" value="0"/>
+            <DoubleSpinBox name="kp:" value="0.6"/>
             <DoubleSpinBox name="ki:" value="0"/>
             <DoubleSpinBox name="sat i:" value="0"/>
-            <DoubleSpinBox name="kd:" value="0"/>
-            <DoubleSpinBox name="sat:" value="0"/>
+            <DoubleSpinBox name="kd:" value="0.15"/>
+            <DoubleSpinBox name="sat:" value="0.5"/>
           </GroupBox>
           <GroupBox name="u_z">
             <DoubleSpinBox name="period, 0 for auto" value="0"/>
-            <DoubleSpinBox name="kp:" value="0"/>
-            <DoubleSpinBox name="ki:" value="0"/>
-            <DoubleSpinBox name="sat i:" value="0"/>
-            <DoubleSpinBox name="kd:" value="0"/>
-            <DoubleSpinBox name="offset g:" value="0"/>
-            <DoubleSpinBox name="sat:" value="0"/>
-            <DoubleSpinBox name="offset step:" value="0"/>
+            <DoubleSpinBox name="kp:" value="0.3"/>
+            <DoubleSpinBox name="ki:" value="0.2"/>
+            <DoubleSpinBox name="sat i:" value="0.4"/>
+            <DoubleSpinBox name="kd:" value="0.15"/>
+            <DoubleSpinBox name="offset g:" value="0.37"/>
+            <DoubleSpinBox name="sat:" value="1"/>
+            <DoubleSpinBox name="offset step:" value="0.0002"/>
           </GroupBox>
           <GroupBox name="u_x">